<div id="body" class="container-fluid">
  <div class="row mx-n5">
    <div class="col">
      <h6>CCD</h6>
      <form [formGroup]="form" novalidate>
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>CCD Order Search</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">M5 #/CTN: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="m5ctn" />
                </div>
              </div>
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">H6: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="h5" />
                  <div *ngIf="h5.invalid && (h5.dirty || h5.touched)">
                    <span *ngIf="h5.errors.invalidH1" class="form-text text-danger">
                      H6 field is not in correct format. H6 should contain 9 digits only.
                    </span>
                  </div>
                </div>
              </div>
            </div>
            <div class="form-row text-center mt-1">
              <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
                <button type="button" class="btn btn-sm btn-primary btn-block" (click)="search()">
                  Search
                </button>
              </div>
              <div class="form-group form-group-sm col-12 col-md-6 col-lg-4">
                <button type="reset" class="btn btn-sm btn-secondary btn-block" (click)="reset()">
                  Clear
                </button>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>
        <div *ngIf="isSubmitted">
          <mat-accordion>
            <mat-expansion-panel [expanded]="true" class="mb-1">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>Eligible CCD Change Orders</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <dx-data-grid #gridOrder id="gridOrder" [dataSource]="orderList"
                            keyExpr="orderId" [showBorders]="true" [wordWrapEnabled]="true"
                            [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                            (onSelectionChanged)="onOrderSelectionChanged($event)">
                <dxo-sorting mode="multiple"></dxo-sorting>
                <dxo-selection mode="multiple" showCheckBoxesMode="always"
                               selectAllMode="page"></dxo-selection>
                <dxo-paging [pageSize]="10"></dxo-paging>
                <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
                <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                <dxi-column dataField="orderId" caption="OrderID" dataType="number" alignment="left"></dxi-column>
                <dxi-column dataField="ftn" caption="M5 #/CTN" dataType="string"></dxi-column>
                <dxi-column dataField="deviceID" caption="Device" dataType="string"></dxi-column>
                <dxi-column dataField="productType" caption="Product Type" dataType="string"></dxi-column>
                <dxi-column dataField="orderType" caption="Order Type" dataType="string"></dxi-column>
                <dxi-column dataField="h5" caption="H6" dataType="number" alignment="left"></dxi-column>
                <dxi-column dataField="domesticFlag" caption="INTL/DOM" dataType="string"></dxi-column>
                <dxi-column dataField="h1" caption="H1" dataType="number" alignment="left"></dxi-column>
                <dxi-column dataField="orderSubType" caption="Order SubType" dataType="string"></dxi-column>
                <dxi-column dataField="ccd" caption="CCD" dataType="string"
                            cellTemplate="localStartTime"></dxi-column>
                <div *dxTemplate="let cell of 'localStartTime'">
                  <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
                </div>
              </dx-data-grid>
            </mat-expansion-panel>
          </mat-accordion>
          <mat-accordion>
            <mat-expansion-panel [expanded]="true" class="mb-1">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>CCD Form</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">CCD Date: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-date-box type="datetime" width="100%"
                                 [acceptCustomValue]="false"
                                 displayFormat="MM/dd/yyyy hh:mm aa"
                                 [useMaskBehavior]="true"
                                 formControlName="ccdDate">
                    </dx-date-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">CCD Reason: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="ccdReasonList"
                                displayExpr="description"
                                valueExpr="value"
                                formControlName="ccdReason"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-4">Notes: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="notes" rows="5" maxlength="400"></textarea>
                    <small class="form-text text-muted">{{ notes.value?.length > 400 ? 0 : (400 - notes.value?.length) | number }} remaining character/s</small>
                  </div>
                </div>
              </div>
              <div class="form-row text-center mt-1">
                <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
                  <button type="button" class="btn btn-sm btn-primary btn-block" (click)="changeCcd()">
                    Change CCD
                  </button>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
        </div>
      </form>
    </div>
  </div>
</div>
